///****************************************************************************
//// Name:        DFTTSSampleJava with DFTTS Desktop SDK v 3.5.0
//// Purpose:     JNI Layer
//// Author:      Digital Future
//// Modified by:
//// Created:     06/10/2008, updated 07/24/2008
//// RCS-ID:
//// Copyright:   (C) Digital Future 2008. All rights reserved.
//// License:     see license document
//***************************************************************************/

public class JNILayer 
{
	 public native String GetDFTTSVoice( int iVoiceInfoIdIn, 
		    int[] pvetOut, 
		    int[] piVoiceNameLenOut, 
			int[] piVoiceIDOut, 
			short[] plangOut 
			);
	 
	
	 public native void InitDFTTSEngineEx3(int hwndWinOwner,
	            String szNeoSpeechDBFolderPathKate,
	            String szNeoSpeechDBFolderPathPaul,
	            String szNeoSpeechDBFolderPathMiyu,
	            String szNeoSpeechDBFolderPathShow,
	            String szNeoSpeechDBFolderPathMisaki,
	            String szNeoSpeechDBFolderPathLily,
	            String szNeoSpeechDBFolderPathWang,
	            String szNeoSpeechDBFolderPathJunwoo,
	            String szNeoSpeechDBFolderPathSujin,
	            String szNeoSpeechDBFolderPathYumi,
	            String szNeoSpeechDBFolderPathGyuri,
	            String szNeoSpeechDBFolderPathDayoung,
	            String szNeoSpeechLicFilePathKate,
	            String szNeoSpeechLicFilePathPaul,
	            String szNeoSpeechLicFilePathMiyu,
	            String szNeoSpeechLicFilePathShow,
	            String szNeoSpeechLicFilePathMisaki,
	            String szNeoSpeechLicFilePathLily,
	            String szNeoSpeechLicFilePathWang,
	            String szNeoSpeechLicFilePathJunwoo,
	            String szNeoSpeechLicFilePathSujin,
	            String szNeoSpeechLicFilePathYumi,
	            String szNeoSpeechLicFilePathGyuri,
	            String szNeoSpeechLicFilePathDayoung,
	            int[] psiLoadedEngines,
	            int[] psiLoadedEnginesReturnValues
	    );
	    
	    public native int UninitDFTTSEngine();
	    
		public native short MakeLanguage( short mainlang, 
					short sublang 
					);

	    public native short GetMainLanguage( short lang );

	    public native short  GetSubLanguage( short lang );
		 
	    
        public native int LoadDFTTSUserDict(int iDictIndex, String szDictName, 
        		String szDictFileName, int vet, short lang, 
        		String szVoiceName, String szDictContents);

        public native int UnloadDFTTSUserDict(int iDictIndex, String szDictName, 
                int vet, short lang);
	    
	    public native int DFTTSSpeak(int hwndWinOwner, int vet,
	            String szVoiceName, int iVoiceID, short lang, String szText, int iPitch, 
	            int iSpeed, int iVolume, int iPause, int iDictID, int ttTextType, 
	            short ofOutPutFormat);
		
	    public native int  DFTTSPause( int vet, short lang );

	    public native int  DFTTSResume( int vet, short lang );
	    
	    public native int  DFTTSStop( int vet, short lang );
	    
	    public native int DFTTSExportToFileEx(int vet, String szVoiceName, 
	            int iVoiceID, short lang, String szText, int iPitch, int iSpeed, 
	            int iVolume, int iPause, int iDictID, int ttTextType, String szFilePath,
	            short ffFileFormat, String szAudioEncoding, int iAudioSamplingRate, 
	            int iAudioChannels);	    
	    
	    static 
	    { 
	    	System.out.println(System.getProperty("java.library.path"));
	    	System.out.println("\nYou MUST put the JNI DLL / JNILIB, AND all dependent libraries for: " +
	    			"Windows (dftts.dll, swift.dll, vt_eng.dll, " +
	    			"vt_kor.dll, vt_jpn.dll, and vt_chi.dll); for Mac OS X (the dfftsssdk.framework must be placed in /Library/Frameworks); " +
	    			"for Linux (libswift.so, libceplang..., libceplex...); " +
	    			"in any of the above directories or just add a desired directory with ALL above libraries in it " +
	    			"to the PATH and restart Eclipse");
	    	
	   	    	
	        System.loadLibrary("dfttsjni"); 
	        
	        

	    }
	    
	    public Frame1 frame;
	    
	    public void setFrame(Frame1 frame1)
	    {
	    	frame = frame1;
	    	
	    }
	    
	   //MACOSXSPMAN: onExport event data is sent here (onWord). MACOSXSPMAN treats exports as speech.
	    
	    public void onWord(int start, int end)
	    {
	    		    	
	  	    if(start==0 && end==-1)
	  	    {
	  	    	frame.bIsSpeaking = false;
	  	    	frame.bIsPaused=false;
	  	    	
	  	    	if( frame.button2.isEnabled())
	  	    		frame.button2.setEnabled(false);
	  	    	
	  	    	if( frame.button3.isEnabled())
	  	    		frame.button3.setEnabled(false);
	  	    	
	  	    }
	  	    else
	  	    {	
	  	    	if( !frame.button2.isEnabled())
	  	    		frame.button2.setEnabled(true);
	  	    	
	  	    	if( !frame.button3.isEnabled())
	  	    		frame.button3.setEnabled(true);     	
	  	    	
	  	    }
	  	    
	  	    
	    	frame.label1.setText("onWord: Start Character: " + start  + ", End Character: " + end);
	    	
    		
	    }	
	    
	   //MACOSXSPMAN: Do not use. Event data is sent to onWord	    
	    public void onExport(int start, int end)
	    {
	  	    //start and end are SDK-reserved	    	
	    		    	
	    	frame.label1.setText("onExport: Export successful!");
	    
	    }	    
  
}
